package com.unipi.talepis.bscplh20249;

import java.sql.*;

public class Main {
    //Βήμα 1. ConnectionString
    static String connectionString = "jdbc:sqlite:firstDB.db";
    //Βήμα 2. Connection object
    static Connection connection;
    public static void main(String[] args) {
        //System.out.println("Hello world!");
        //createTableAndData();
        selectAllRecords();
        //selectByAM("P23002");
        //insertNewStudent("p23007","bond@gmail.com","james");
    }
    //΄Βήμα 3. Instantiate connection object
    private static Connection connect(){
        try {
            Connection connection = DriverManager.getConnection(connectionString);
            return connection;
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
    private static void createTableAndData(){
        connection = connect();
        String createTableSQL = "CREATE TABLE if not exists STUDENT(" +
                "AM TEXT PRIMARY KEY," +
                "EMAIL TEXT," +
                "FULLNAME TEXT)";
        String insertSQL = "INSERT OR IGNORE INTO STUDENT VALUES('P23003','maria@unipi.gr'," +
                "'maria paparizou')";
        //Δημιουργία αντικειμένου Statement
        try {
            Statement statement = connection.createStatement();
            statement.execute(createTableSQL);
            statement.execute(insertSQL);
            statement.close();
            connection.close();
            System.out.println("Done!");
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
    public static void selectAllRecords(){
        connection = connect();
        String selectSQL = "SELECT * FROM STUDENT";
        //Δημιουργία αντικειμένου Statement
        try {
            Statement statement = connection.createStatement();
            //Δημιουργία αντικειμένου resultset για την αποθήκευση των επιστρεφόμενων δεδομένων
            ResultSet resultSet = statement.executeQuery(selectSQL);
            //Loop για την ανάγνωση του resultset
            StringBuilder builder = new StringBuilder();
            while (resultSet.next()){
                builder.append("Student name: ")
                        .append(resultSet.getString("FULLNAME"))
                        .append("\n");
            }
            System.out.println(builder.toString());
            resultSet.close();
            statement.close();
            connection.close();
            System.out.println("Done!");
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
    public static void selectByAM(String am){
        connection = connect();
        String selectSQL = "SELECT * FROM STUDENT where AM=?";
        //Δημιουργία αντικειμένου PreparedStatement
        try {
            PreparedStatement statement = connection.prepareStatement(selectSQL);
            statement.setString(1,am);
            //Δημιουργία αντικειμένου resultset για την αποθήκευση των επιστρεφόμενων δεδομένων
            ResultSet resultSet = statement.executeQuery();
            //Loop για την ανάγνωση του resultset
            StringBuilder builder = new StringBuilder();
            while (resultSet.next()){
                builder.append("Student name: ")
                        .append(resultSet.getString("FULLNAME"))
                        .append("\n");
            }
            System.out.println(builder.toString());
            resultSet.close();
            statement.close();
            connection.close();
            System.out.println("Done!");
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
    public static void insertNewStudent(String am,String email,String name){
        connection = connect();
        String insertSQL = "INSERT INTO STUDENT VALUES(?,?,?)";
        //Δημιουργία αντικειμένου PreparedStatement
        try {
            PreparedStatement statement = connection.prepareStatement(insertSQL);
            statement.setString(1,am);
            statement.setString(2,email);
            statement.setString(3,name);
            statement.executeUpdate();
            statement.close();
            connection.close();
            System.out.println("Done!");
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
}